/*
   This code is from "Algorithms in Java, Third Edition,"
   by Robert Sedgewick, Addison-Wesley, 2003,
   pages 317, 319.
*/

#define exch(A, B) { int t = A; A = B; B = t; }


int partition(int a[], int q, int r)
{
   int x = a[r];
   int i = q-1, j = r;
   for (;;)
   {
      while (a[++i] < x) ;
      while (x < a[--j]) if (j == q) break;
      if (i >= j) break;
      exch(a[i], a[j]);
   }
   exch(a[i], a[r]);
   return i;
}


void quicksort(int a[], int q, int r)
{
   int p;
   if (r <= q) return;
   p = partition(a, q, r);
   quicksort(a, q, p-1);
   quicksort(a, p+1, r);
}
